#define USE_INLINE_STDARG
#include <proto/muimaster.h>
#include <proto/intuition.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <dos/dosextens.h>
#include <libraries/mui.h>
#include <clib/alib_protos.h>
#include <string.h>

BOOL GUI(BOOL do_user, char *user, ULONG user_len, char *pass, ULONG pass_len, struct Library * SysBase)
{
	struct Library *MUIMasterBase = OpenLibrary("muimaster.library", MUIMASTER_VLATEST);
	struct Library *IntuitionBase = OpenLibrary("intuition.library", 51);
	BOOL rc = FALSE;
	
	if (MUIMasterBase && IntuitionBase)
	{
		CONST_STRPTR str;
		Object *W, *S, *OK, *U;
		Object *A = MUI_NewObject(MUIC_Application,
			MUIA_Application_Base, (IPTR)"SMBFS",
			MUIA_Application_Title, (IPTR)"SMBFS",
			MUIA_Application_UseCommodities, FALSE,
			MUIA_Application_UseRexx, FALSE,
			SubWindow,
				W = MUI_NewObject(MUIC_Window,
					MUIA_Window_Title, (IPTR)"SMBFS Share Credentials",
					MUIA_Window_CloseGadget, TRUE,
					MUIA_Window_DepthGadget, TRUE,
					MUIA_Window_SizeGadget, TRUE,
					MUIA_Window_DragBar, TRUE,
					MUIA_Window_Width, 400,
					WindowContents,
						(IPTR)MUI_NewObject(MUIC_Group, MUIA_Group_Horiz, FALSE,
						
							Child, (IPTR)MUI_NewObject(MUIC_Group, MUIA_Group_Columns, 2,
								Child, (IPTR)Label("User:"),
								Child, U = MUI_NewObject(MUIC_String, 
									MUIA_CycleChain, TRUE, MUIA_Disabled, !do_user, 
									MUIA_String_MaxLen, user_len, StringFrame, 
									MUIA_String_AdvanceOnCR, TRUE,
									MUIA_String_Contents, (IPTR)user,
									TAG_DONE),
								Child, (IPTR)Label("Password:"),
								Child, S = MUI_NewObject(MUIC_String, 
									MUIA_CycleChain, TRUE, 
									MUIA_String_MaxLen, pass_len, 
									MUIA_String_Secret, TRUE, StringFrame,
									MUIA_String_AdvanceOnCR, TRUE,
									TAG_DONE),
								TAG_DONE),
							Child, (IPTR)MUI_NewObject(MUIC_Group, MUIA_Group_Horiz, TRUE,
								Child, (IPTR)MUI_NewObject(MUIC_Rectangle, TAG_DONE),
								Child, OK = SimpleButton("OK"),
								Child, (IPTR)MUI_NewObject(MUIC_Rectangle, TAG_DONE),
							TAG_DONE),
						TAG_DONE),
				TAG_DONE),
			TAG_DONE);

		DoMethod(W,MUIM_Notify,MUIA_Window_CloseRequest,TRUE,(IPTR)S,3,MUIM_Set, MUIA_String_Contents, (IPTR)"");
		DoMethod(W,MUIM_Notify,MUIA_Window_CloseRequest,TRUE,(IPTR)A,2,MUIM_Application_ReturnID,MUIV_Application_ReturnID_Quit);
		DoMethod(OK,MUIM_Notify,MUIA_Pressed,FALSE,(IPTR)A,2,MUIM_Application_ReturnID,MUIV_Application_ReturnID_Quit);
	
		SetAttrs(OK, MUIA_CycleChain, TRUE, TAG_DONE);
		SetAttrs(W, MUIA_Window_Open,TRUE,TAG_DONE);
		SetAttrs(W, MUIA_Window_ActiveObject, MUIV_Window_ActiveObject_Next, TAG_DONE);

		{
			ULONG sigs = 0;

			while (DoMethod(A,MUIM_Application_NewInput,(IPTR)&sigs) != MUIV_Application_ReturnID_Quit)
			{
				if (sigs)
				{
					sigs = Wait(sigs | SIGBREAKF_CTRL_C);
					if (sigs & SIGBREAKF_CTRL_C) break;
				}
			}
		}

		SetAttrs(W,MUIA_Window_Open,FALSE,TAG_DONE);

		if (do_user)
		{
			get(U, MUIA_String_Contents, &str);
			
			if (str)
			{
				stccpy(user, str, user_len);
			}
		}

		get(S, MUIA_String_Contents, &str);
		
		if (str)
		{
			stccpy(pass, str, pass_len);
			rc = pass[0];
		}

		MUI_DisposeObject(A);
	}

	CloseLibrary(IntuitionBase);
	CloseLibrary(MUIMasterBase);
	
	return rc;
}
